function GG2_adm(action)

global scale cp


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GG2_adm('update graphics')
   
   
case 'my fcn'
   GG2_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hl=findobj(gcbf,'Tag','l');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   l=eval(get(hl,'String'));
   x=XLim(1):diff(XLim)/20:XLim(2);
   y=YLim(1):diff(YLim)/20:YLim(2);
   [x,y]=meshgrid(x,y);

   hf=findobj(gcbf,'Tag','f gallery');
   string=get(hf,'String');
   val=get(hf,'Value');
   fxy=string{val};
   h=findobj(gcbf,'Tag','z=f(x,y)');
   if isempty(fxy)
      set(h,'Visible','off')
   else
      f=eval(fxy).*ones(size(x));
      set(h,'XData',x,'YData',y,'ZData',f,'CData',f,'Visible','on')
   end
   
   h=findobj(gcbf,'Tag','g(x,y)');
   gxy=get(h,'String');
   h=findobj(gcbf,'Tag','z=g(x,y)');
   if isempty(gxy)
      set(h,'Visible','off')
   else
      g=eval(gxy);
      set(h,'XData',x,'YData',y,'ZData',g,'CData',g,'Visible','on')
   end
   
   set(gca,'ZLim',ZLim)
   rotate3d on
   
   title(string{val})
      
   
case 'a'
   GG2_adm('update graphics')
   
   
case 'k'
   GG2_adm('update graphics')
   
   
case 'l'
   GG2_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GG2_adm('update graphics')
   
   
case 'k slider'
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k*10;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   GG2_adm('update graphics')
   
   
case 'l slider'
   hl=findobj(gcbf,'Tag','l slider');
   l=get(hl,'Value');
   l=l*10;
   hl=findobj(gcbf,'Tag','l');
   set(hl,'String',num2str(l,'%1.1f'))
   GG2_adm('update graphics')
   
   
case 'mesh'
   hm=findobj(gcbf,'Tag','mesh');
   if get(hm,'String')=='mesh on '
      h=findobj(gcbf,'Tag','z=f(x,y)');
      set(h,'EdgeColor',[0 0 0])
      h=findobj(gcbf,'Tag','z=g(x,y)');
      set(h,'EdgeColor',[0 0 0])
      set(hm,'String','mesh off')
   elseif get(hm,'String')=='mesh off'
      h=findobj(gcbf,'Tag','z=f(x,y)');
      set(h,'EdgeColor','none')
      h=findobj(gcbf,'Tag','z=g(x,y)');
      set(h,'EdgeColor','none')
      set(hm,'String','mesh on ')
   end
   
   
case 'light'
   hm=findobj(gcbf,'Tag','light knob');
   if get(hm,'String')=='light on '
      h=findobj(gcbf,'Tag','light');
      set(h,'Color',[1 1 1])
      h=findobj(gcbf,'Type','Surface');
      set(h,'FaceLighting','flat')
      set(hm,'String','light off')
   elseif get(hm,'String')=='light off'
      h=findobj(gcbf,'Tag','light');
      set(h,'Color',[0 0 0])
      h=findobj(gcbf,'Type','Surface');
      set(h,'FaceLighting','none')
      set(hm,'String','light on ')
   end
   
   
case 'set axis'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   dZ=scale*diff(ZLim);
   cp(1)=sum(XLim)/2;
   cp(2)=sum(YLim)/2;
   cp(3)=sum(ZLim)/2;
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   NewZLim=[cp(3)-dZ/2 cp(3)+dZ/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim,'ZLim',NewZLim)
   GG2_adm('update graphics')
   
   
case 'R22R'
   close(gcf)
   open('GGR22R.fig')
   
case 'R2R2'
   close(gcf)
   open('GGR2R2.fig')
   
case 'R22R2'
   close(gcf)
   open('GGR22R2.fig')
   
case '1st floor'
   close(gcf)
   open('GG.fig')
   
case 'close'
   close(gcf)
   
end
