function GGgen_adm(action)

global scale cp qw


switch action
   
   
case 'Df'
   h=findobj(gcbf,'Tag','Df');
   Df=get(h,'String');
   Df=eval(Df);
   h=findobj(gcbf,'Tag','x slider');
   set(h,'Min',Df(1),'Max',Df(2),'SliderStep',[0.02 0.03])
   
   
case 'Dg'
   h=findobj(gcbf,'Tag','Dg');
   Dg=get(h,'String');
   Dg=eval(Dg);
   h=findobj(gcbf,'Tag','y slider');
   set(h,'Min',Dg(1),'Max',Dg(2),'SliderStep',[0.02 0.03])
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GGgen_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dx=diff(XLim);
   h=findobj(gcbf,'Tag','x');
   x=get(h,'String');
   x=eval(x);
   h=findobj(gcbf,'Tag','f gallery');
   str=get(h,'String');
   val=get(h,'Value');
   fx=str{val};
   f=eval(fx);
   h=findobj(gcbf,'Tag','x-text');
   set(h,'String','x','Position',[x-.01*dx -.017*dx*f/(abs(f)+eps)])
   h=findobj(gcbf,'Tag','y-text');
   set(h,'String','f(x)','Position',[-.05*dx*(.5+x/(abs(x)+eps)) f])
   
   ha2m=findobj(gcbf,'Tag','a2m');
   set(ha2m,'XData',[x x 0],'Ydata',[0 f f])
   
   h=findobj(gcbf,'Tag','Df');
   Df=get(h,'String');
   Df=eval(Df);
   dx=diff(Df);
   x=Df(1):dx/100:Df(2);
   f=eval(fx);
   h=findobj(gcbf,'Tag','y=f(x)');
   set(h,'XData',x,'YData',f)
   
   
   h=findobj(gcbf,'Tag','y slider');
   gy=get(findobj(gcbf,'Tag','g(y)'),'String');
   if isempty(gy)
      set(findobj(gcbf,'Tag','x=g(y)'),'Visible','off')
      set(h,'Max',max(f),'Min',min(f))
   else
      set(findobj(gcbf,'Tag','x=g(y)'),'Visible','on')
   end
   h2=findobj(gcbf,'Tag','g(y)');
   if (gcbo==h | gcbo==h2) & (~isempty(gy))
     YLim=get(gca,'YLim');
     dy=diff(YLim);
     h=findobj(gcbf,'Tag','y');
     y=get(h,'String');
     y=eval(y);
     h=findobj(gcbf,'Tag','g(y)');
     gy=get(h,'String');
     g=eval(gy);
   
     h=findobj(gcbf,'Tag','x-text');
     set(h,'String','g(y)','Position',[g-.07*dx -.04*dx*y/(abs(y)+eps)])
     h=findobj(gcbf,'Tag','y-text');
     set(h,'String','y','Position',[-.04*dx*(.5+g/(abs(g)+eps)) y])
   
     ha2m=findobj(gcbf,'Tag','a2m');
     set(ha2m,'XData',[g g 0],'Ydata',[0 y y])
   
     h=findobj(gcbf,'Tag','Dg');
     Dg=get(h,'String');
     Dg=eval(Dg);
     dy=diff(Dg);
     y=Dg(1):dy/100:Dg(2);
     g=eval(gy);
     h=findobj(gcbf,'Tag','x=g(y)');
     set(h,'XData',g,'YData',y)
   end
   
   h=findobj(gcbf,'Tag','y slider');
   gy=get(findobj(gcbf,'Tag','g(y)'),'String');
   if gcbo==h & isempty(gy)
     h=findobj(gcbf,'Tag','y');
     y=get(h,'String');
     y=eval(y);
     h=findobj(gcbf,'Tag','Df');
     Df=get(h,'String');
     Df=eval(Df);
     dx=diff(Df);
     x=Df(1):dx/100:Df(2);
     f=eval(fx);
     l=length(f);
     fm=f(1:l-1);
     fp=f(2:l);
     ind=((fm-y).*(fp-y)<=0);
     if sum(ind)>1
        disp('Cannot determine a unique x s.t. f(x) = y')
        h=findobj(gcbf,'Tag','x-text');
        set(h,'Visible','off')
        h=findobj(gcbf,'Tag','y-text');
        set(h,'String','y','Position',[-.07*dx y])
   
        ha2m=findobj(gcbf,'Tag','a2m');
        %   set(ha2m,'Visible','off')
        x0=x(ind);
        y0=f(ind==1);
        y0=y0(1:2);
        set(ha2m,'XData',[min(x0) max(x0)],'YData',y0)
     else
        x0=x(ind);
     
        h=findobj(gcbf,'Tag','x-text');
        set(h,'String','f^-^1(y)','Position',[x0-.1*dx -.06*dx*y/(abs(y)+eps)],'Visible','on')
        h=findobj(gcbf,'Tag','y-text');
        set(h,'String','y','Position',[-.05*dx*(.5+x0/(abs(x0)+eps)) y])
   
        ha2m=findobj(gcbf,'Tag','a2m');
        set(ha2m,'XData',[x0 x0 0],'Ydata',[0 y y],'Visible','on')
     end
   end
   tit='y = f(x)';
   if ~isempty(gy)
      tit=[tit '  and  x = g(y)'];
   end
   h=findobj(gcbf,'Tag','x_axis');
   set(h,'XData',XLim)
   h=findobj(gcbf,'Tag','y_axis');
   set(h,'YData',YLim)
   title(tit)
      
   
case 'x'
   GGgen_adm('update graphics')
   
   
case 'y'
   GGgen_adm('update graphics')
   
   
case 'x slider'
   h=findobj(gcbf,'Tag','x slider');
   x=get(h,'Value');
   h=findobj(gcbf,'Tag','x');
   set(h,'String',num2str(x,'%1.2f'))
   GGgen_adm('update graphics')
   
   
case 'y slider'
   h=findobj(gcbf,'Tag','y slider');
   y=get(h,'Value');
   h=findobj(gcbf,'Tag','y');
   set(h,'String',num2str(y,'%1.2f'))
   GGgen_adm('update graphics')
      
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','GGgen_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','GGgen_adm(''set axis'')')
   scale=2;
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','GGgen_adm(''set axis'')')
   scale=1;
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   GGgen_adm('update graphics')
   
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','GGgen_adm(''start drag'')')
   
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','GGgen_adm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','GGgen_adm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   GGgen_adm('Update graphics')
   
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   GGgen_adm('update graphics')
   
   
case 'back'
   close(gcbf)
   open('GG.fig')
   
   
case 'close'
   close(gcf)
   
   
case 'questions'
   if get(gcbo,'String')=='questions'
      set(gcbo,'String',  'close    ')
   elseif get(gcbo,'String')=='close    '
      set(gcbo,'String','questions')
      close(qw)
      return
   end
   qw=figure('units','normalized');
   set(qw,'Position',get(gcbf,'Position'))
   set(gcf,'Position',get(gcf,'Position')+[-.4 0.2 -.2 -0.2])
   h=findobj(qw,'Tag','figMenuTools');
   set(h,'HandleVisibility','off')
   ht=uicontrol('style','text',...
      'Units','normalized',...
      'Position',[.05 .15 .9 .8],...
      'Tag','text',...
      'HorizontalAlignment','left',...
      'FontSize',12,...
      'FontWeight','demi');
   ht=uicontrol('style','slider',...
      'Units','normalized',...
      'Position',[.05 0.05 .3 .05],...
      'SliderStep',[.1 .2],...
      'Tag','slider',...
      'Callback','GGgen_adm(''roll'')');
   hh=uicontrol('style','pushbutton',...
      'Units','normalized',...
      'Position',[0.6 0.05 .2 .05],...
      'Tag','hide',...
      'String','hide',...
      'Callback','GGgen_adm(''hide'')');
   GGgen_adm('def string')
   GGgen_adm('roll')
   
   
   
case 'hide'
   hf=findobj(1,'Type','axes');
   h=get(hf,'title');
   set(h,'Color',[.8 .8 .8]);
   h=findobj(1,'Tag','a');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj(1,'Tag','k');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj(1,'Tag','m');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj(qw,'String','hide');
   set(h,'String','show','Callback','GGgen_adm(''show'')')
   
   
case 'show'
   hf=findobj(1,'Type','axes');
   h=get(hf,'title');
   set(h,'Color',[0 0 1]);
   h=findobj(1,'Tag','a');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj(1,'Tag','k');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj(1,'Tag','m');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj(qw,'String','show');
   set(h,'String','hide','Callback','GGgen_adm(''hide'')')
   
   
case 'roll'
   ht=findobj(qw,'Tag','text');
   hs=findobj(qw,'Tag','slider');
   val=get(hs,'Value');
   string=get(ht,'UserData');
   l=length(string);
   m=min(l,round(val*30)+1);
   M=min(l,round(val*30)+14);
   set(ht,'String',string(m:M))

      
case 'def string'
string={...
   '  1. ';...
   '';...
   '  2. ';...
   '';...
   '  3. ';...
   ''};
   
   h=findobj(qw,'Tag','text');
   set(h,'UserData',string)

   
   
   
end
