function ZoomSolve_adm(action)

global scale NewXLim NewYLim

switch action

case 'zoom in'
  
  scale=.5;
  set(gcf,'WindowButtonDownFcn','ZoomSolve_adm(''zoom'')')


case 'zoom out'
  
  scale=2;
  set(gcf,'WindowButtonDownFcn','ZoomSolve_adm(''zoom'')')
  
  
case 'zoom'
   
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   ZoomSolve_adm('plot_fcn')      
   
   
case 'choose_fcn'

  value=get(findobj(gcbf,'Tag','f_gallery'),'Value');
  string=get(findobj(gcbf,'Tag','f_gallery'),'String');
  f=string{value};

  set(findobj(gcbf,'Tag','my_fcn'),'String',f)
  ZoomSolve_adm('plot_fcn')


case 'plot_fcn'

  delete(findobj(gcbf,'Tag','f_graph'))
  title('')

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)
    disp('no graph to plot')
  else
    f=get(findobj(gcbf,'Tag','my_fcn'),'String');
    XLim=get(gca,'XLim');
    YLim=get(gca,'YLim');
    dX=diff(XLim);
    x=XLim(1):dX/1000:XLim(2);
    y=eval(f);
    line(x,eval(f),'Color','r','Tag','f_graph')
    title(['y = f(x)'])
    axis([x(1) x(length(x)) min(y)-.5 max(y)+.5]);
    set(findobj('Tag','x_axis'),'XData',XLim)
    set(findobj('tag','y_axis'),'Ydata',YLim)
    h=findobj(gcbf,'Tag','y=0');
    set(h,'XData',XLim);
    set(gca,'XLim',XLim,'YLim',YLim)
  end
   

end




