function Eadm(action)

global index mode duals LS su cp

%ax=findobj(gcbf,'Tag','CurrentAxes');
%if ~(ax==findobj(gcbf,'Tag','Axes2'))
%  Eadm('rotate')
%end

axes(findobj(gcf,'Tag','Axes1'))

switch action


case 'lines'

  str=get(findobj(gcbf,'Tag','lines'),'String');
  if str=='lines on '
    Eadm('lines on')
    set(findobj(gcbf,'Tag','lines'),'String','lines off')
  elseif str=='lines off'
    Eadm('lines off')
    set(findobj(gcbf,'Tag','lines'),'String','lines on ')
  end


case 'update formulas'

  axes(findobj(gcbf,'Tag','Axes3'))
  
  h=findobj(gcbf,'Color',[1 0 0]);
  %if isempty(h)
   %  set(findobj(gcbf,'Tag','eq1'),'String','')
    % pause(4)
     %get(findobj(gcbf,'Tag',['eq' num2str(1)]),'String')
 %set(findobj(gcbf,'Tag','eq1'),'String','')
     %break
  %end
  %set(findobj(gcbf,'Tag','eq1'),'Visible','on')
  %set(findobj(gcbf,'Tag','kol1'),'Visible','on')
  l=length(h);
  neqs=min(3,l);
  
  for j=1:neqs
    X=get(h(l+1-j),'XData');
    Y=get(h(l+1-j),'YData');
    p=[X(1) Y(1)];
    n=[diff(X(1:2)) diff(Y(1:2))];
    tag=get(h(l+1-j),'Tag');
    if tag=='tangent'
      n=[-n(2) n(1)];
    end
    eqs(j,1:2)=n;
    eqs(j,3)=n*p';
  end
    
% equations

  for i=1:neqs
    text=[];
    if eqs(i,1)<0
      text=[text '- '];
    else
      text=[text '   '];
    end
    text=[text num2str(abs(eqs(i,1)),'%1.1f') '  x_1 '];
    if eqs(i,2)<0
      text=[text '  -  '];
    else
      text=[text ' +  '];
    end
    text=[text num2str(abs(eqs(i,2)),'%1.1f') '  x_2  =  '];
    if eqs(i,3)<0
      text=[text '-' num2str(abs(eqs(i,3)),'%1.1f')];
    else
      text=[text '  ' num2str(abs(eqs(i,3)),'%1.1f')];
    end
    set(findobj(gcbf,'Tag',['eq' num2str(i)]),'String',text)
  end

% kolumns

  for i=1:3
    text=[];
    for j=1:neqs
      if eqs(j,i)<0
        text=[text;'-' num2str(abs(eqs(j,i)),'%1.1f')];
      else
        text=[text;' ' num2str(abs(eqs(j,i)),'%1.1f')];
      end
    end
    set(findobj(gcbf,'Tag',['kol' num2str(i)]),'String',text)
  end


case 'toggle form'
  
   str=get(findobj(gcbf,'Tag','eq form'),'String');
   if str=='vect form'
      
    set(findobj(gcbf,'Tag','eq form'),'String','comp form')
 else
    set(findobj(gcbf,'Tag','eq form'),'String','vect form')
 end
 
    Eadm('update formulas')
    Eadm('show formulas')
   
case 'show formulas'

  axes(findobj(gcbf,'Tag','Axes3'))
  h=findobj(gcbf,'Color',[1 0 0]);
   
  l=length(h);
  neqs=min(3,l);
  str=get(findobj(gcbf,'Tag','eq form'),'String');

  if str=='vect form'

    %set(findobj(gcbf,'Tag','eq form'),'String','comp form')
    for i=1:3
      set(findobj(gcbf,'Tag',['eq' num2str(i)]),'Visible','off')
    end

    set(findobj(gcbf,'Tag','x1'),'Visible','on')
    set(findobj(gcbf,'Tag','x2'),'Visible','on')
    for i=1:3
      set(findobj(gcbf,'Tag',['kol' num2str(i)]),'Visible','on')
%     set(findobj(gcbf,'Tag',['kol' num2str(i)]),'Position',[])
    end

  elseif str=='comp form'

    %set(findobj(gcbf,'Tag','eq form'),'String','vect form')
    for i=1:3
      set(findobj(gcbf,'Tag',['kol' num2str(i)]),'Visible','off')
    end
    set(findobj(gcbf,'Tag','x1'),'Visible','off')
    set(findobj(gcbf,'Tag','x2'),'Visible','off')
    
    for i=neqs:3
       set(findobj(gcbf,'Tag',['eq' num2str(i)]),'Visible','off')
    end
    

    for i=1:neqs
      set(findobj(gcbf,'Tag',['eq' num2str(i)]),'Visible','on')
%     set(findobj(gcbf,'Tag',['eq' num2str(i)]),'Position',[])
    end

  end


case 'update kolumn space'

   h=findobj(gcbf,'Color',[1 0 0]);
   %if isempty(h)
    %  break
   %end
   
  l=length(h);
  neqs=min(3,l);

  eqs=[];
  for j=1:neqs
    X=get(h(l+1-j),'XData');
    Y=get(h(l+1-j),'YData');
    p=[X(1) Y(1)];
    n=[diff(X(1:2)) diff(Y(1:2))];
    tag=get(h(l+1-j),'Tag');
    if tag=='tangent'
      n=[-n(2) n(1)];
    end
    eqs(j,1:2)=n;
    eqs(j,3)=n*p';
  end

  axes(findobj(gcbf,'Tag','Axes2'))

  eqs=[eqs;0 0 0;0 0 0];
  [X,Y,Z]=arrow3([0 0 0],eqs(1:3,1));
  set(findobj(gcbf,'Tag','k1'),...
       'XData',X,'YData',Y,'ZData',Z,'LineWidth',2,'Visible','on')
  [X,Y,Z]=arrow3([0 0 0],eqs(1:3,2));
  set(findobj(gcbf,'Tag','k2'),...
       'XData',X,'YData',Y,'ZData',Z,'LineWidth',2,'Visible','on')
  [X,Y,Z]=arrow3([0 0 0],eqs(1:3,3));
  set(findobj(gcbf,'Tag','k3'),...
       'XData',X,'YData',Y,'ZData',Z,'LineWidth',2,'Visible','on')
  X=get(findobj('Tag','solution'),'XData');
  Y=get(findobj('Tag','solution'),'YData');
  x1=X(1);
  x2=Y(1);
  [X,Y,Z]=arrow3([0 0 0],x1*eqs(1:3,1)+x2*eqs(1:3,2));
  set(findobj(gcbf,'Tag','lin comb'),...
       'XData',X,'YData',Y,'ZData',Z,'LineWidth',2,'Visible','on')
  set(findobj(gcbf,'Tag','guide line'),...
      'XData',[eqs(1,1) x1*eqs(1,1) x1*eqs(1,1)+x2*eqs(1,2) ...
                        x2*eqs(1,2) eqs(1,2)],...
      'YData',[eqs(2,1) x1*eqs(2,1) x1*eqs(2,1)+x2*eqs(2,2) ...
                        x2*eqs(2,2) eqs(2,2)],...
      'ZData',[eqs(3,1) x1*eqs(3,1) x1*eqs(3,1)+x2*eqs(3,2) ...
                        x2*eqs(3,2) eqs(3,2)])

  if neqs==3
    view(30,10)
    n=cross(eqs(1:3,1),eqs(1:3,2));
    X=get(gca,'XLim');
    Y=get(gca,'YLim');
    x=linspace(X(1),X(2),50);
    y=linspace(Y(1),Y(2),50);
    e=ones(size(x));
    z=-n(1)/n(3)*e'*x-n(2)/n(3)*y'*e;
    set(findobj(gca,'Tag','plane'),'ZData',z,'Visible','on')
  elseif neqs==2
    view(2)
    set(findobj(gcbf,'Tag','plane'),'Visible','off')
  else
  end


case 'solve eqs'

  h=findobj(gcbf,'Color',[1 0 0]);
  if isempty(h)
     set(findobj(gcbf,'Tag','Pushbutton12'),'TooltipString','Add line first')
     %disp('Add line first')
     break
  end
  
  l=length(h);
  neqs=min(3,l);

  eqs=[];
  for j=1:neqs
    X=get(h(l+1-j),'XData');
    Y=get(h(l+1-j),'YData');
    p=[X(1) Y(1)];
    n=[diff(X(1:2)) diff(Y(1:2))];
    tag=get(h(l+1-j),'Tag');
    if tag=='tangent'
      n=[-n(2) n(1)];
    end
    eqs(j,1:2)=n;
    eqs(j,3)=n*p';
  end  
     
  axes(findobj(gcbf,'Tag','Axes1'))

  if neqs==1
    h0=get(h(1),'Userdata');
    X=get(findobj(gcbf,'Tag',h0),'XData');
    Y=get(findobj(gcbf,'Tag',h0),'YData');
    set(findobj(gcbf,'Tag','solution'),'XData',X,'YData',Y)
  else
    x1x2=(eqs(1:neqs,1:2)'*eqs(1:neqs,1:2))\(eqs(1:neqs,1:2)'*eqs(1:neqs,3));
    x1=x1x2(1);
    x2=x1x2(2);
    set(findobj(gcbf,'Tag','solution'),'LineWidth',4,...
            'XData',[x1 x1],'YData',[x2 x2+0.05],'Visible','on')
    set(findobj(gcbf,'Tag','coords'),...
            'Position',[x1+0.1 x2-0.1 0],...
            'String',['(' num2str(x1,'%1.1f') ',' num2str(x2,'%1.1f') ')'],...
            'Visible','on')
    if neqs==3
       set(findobj(gcbf,'Tag','LS'),...
          'Position',[x1+0.1 x2+0.1 0],'Visible','on')
    end
  end
  Eadm('update kolumn space')


case 'trial sol'
  
  set(findobj(gcbf,'Tag','lines'),'String','lines on ')
  Eadm('coords')
  h=findobj(gcbf,'Color',[1 0 0]);
  l=length(h);
  neqs=min(3,l);

  for j=1:l
    h0=get(h(j),'Userdata');
    set(findobj(gcbf,'Tag',h0),'Visible','off')
    set(h(j),'Visible','off')
  end

  eqs=[];
  for j=1:neqs
    X=get(h(l+1-j),'XData');
    Y=get(h(l+1-j),'YData');
    p=[X(1) Y(1)];
    n=[diff(X(1:2)) diff(Y(1:2))];
    tag=get(h(l+1-j),'Tag');
    if tag=='tangent'
      n=[-n(2) n(1)];
    end
    eqs(j,1:2)=n;
    eqs(j,3)=n*p';
  end  
     
  axes(findobj(gcbf,'Tag','Axes1'))

%  if neqs==1
    h0=get(h(1),'Userdata');
    X=get(findobj(gcbf,'Tag',h0),'XData');
    Y=get(findobj(gcbf,'Tag',h0),'YData');
    set(findobj(gcbf,'Tag','solution'),'XData',X,'YData',Y,'Visible','on')
%  else
    cp=get(findobj(gcbf,'Tag','Axes1'),'CurrentPoint');
    cp=cp(1,1:2);
    x1=cp(1);
    x2=cp(2);
    set(findobj(gcbf,'Tag','solution'),...
            'XData',[x1 x1],'YData',[x2 x2+0.05],'Visible','on')
    set(findobj(gcbf,'Tag','coords'),...
            'Position',[x1+0.05 x2-0.1 0],'Visible','on')
%    if neqs==3
%       set(findobj(gcbf,'Tag','LS'),'Position',[x1+0.05 x2+0.1 0],'Visible','off')
%    end
%  end
  Eadm('update kolumn space')


case 'rotate'

  %axes(findobj(gcbf,'Tag','Axes2'));
  %set(gcbf,'WindowButtonDownFcn','rotation(gcbf,...)')
  %rotation(`gcbf,'rot')
  
  l=length(findobj(gcbf,'Color',[1 0 0]));
  if l>2
     set(findobj(gcbf,'Tag','Axes2'),'Clipping','off')
     rotate3dx
end

  %rotate3d
%disp('rotate3d')
  %set(gcbf,'WindowButtonUpFcn','rotation off')


%case 'rotastop'

%  disp('hello')
%  set(gcbf,'WindowButtonUpFcn','')
%  rotate3d off
%  set(gcbf,'WindowButtonDownFcn','Eadm(''start'')')



case 'coords'

  axes(findobj(gcbf,'Tag','Axes1'))
  cp=get(gca,'CurrentPoint');
  cp=cp(1,1:2);
  x=get(gca,'XLim');
  y=get(gca,'YLim');
       str=['(' num2str(cp(1),'%1.1f') ',' num2str(cp(2),'%1.1f') ')']; 
  set(findobj(gcbf,'Tag','coords'),'Visible','on',...
      'Position',[cp(1) cp(2)+.2],'String',str)
  set(findobj(gcbf,'Tag','x1 guide'),'XData',[cp(1) cp(1)],...
      'YData',[min(cp(2),0) max(cp(2),0)],'Visible','on')
  set(findobj(gcbf,'Tag','x2 guide'),'XData',[min(cp(1),0) ...
        max(cp(1),0)],'YData',[cp(2) cp(2)],'Visible','on')
if cp(1)<=x(1)|cp(1)>=x(2)|cp(2)<=y(1)|cp(2)>=y(2)

  set(findobj(gcbf,'Tag','coords'),'Visible','off')
  set(findobj(gcbf,'Tag','x1 guide'),'Visible','off')
  set(findobj(gcbf,'Tag','x2 guide'),'Visible','off')

end


case 'new line'

  axes(findobj(gcbf,'Tag','Axes1'))
  Eadm('un-current')
  tag=get(gco,'Tag');
  p0=eval(get(findobj(gcbf,'Tag','EditText2'),'String'));
  v =eval(get(findobj(gcbf,'Tag','EditText3'),'String'));
  n=[-v(2) v(1)];
  p=p0;
  XLim=get(gca,'XLim');
  YLim=get(gca,'YLim');
  X=[p(1)-10*v(1) p(1)+10*v(1)];
  Y=[p(2)-10*v(2) p(2)+10*v(2)];
  h0=line('XData',X,'YData',Y,'Color','b','LineWidth',1);
  set(h0,'Tag',num2str(h0))
  if tag=='EditText4'
    [X,Y]=arrow(p,n);
    h=findobj(gcbf,'Color',[0 0 1]);
    l=length(h);
    duals(l,1:2)=n;
    duals(l,3)=p*n';
    handle=line('XData',X,'YData',Y,'Tag','normal ');
  elseif tag=='EditText3'
    [X,Y]=arrow(p,v);
    n=[-v(2) v(1)];
    h=findobj(gcbf,'Color',[0 0 1]);
    l=length(h);
    duals(l,1:2)=n;
    duals(l,3)=p*n';
    handle=line('XData',X,'YData',Y,'Tag','tangent');
  end
  [X,Y,Z]=arrow3([0 0 0],[duals(1,1) duals(2,1) duals(3,1)]);
  set(findobj(gcbf,'Tag','dual1'),'XData',X,'YData',Y,'ZData',Z)
  [X,Y,Z]=arrow3([0 0 0],[duals(1,2) duals(2,2) duals(3,2)]);
  set(findobj(gcbf,'Tag','dual2'),'XData',X,'YData',Y,'ZData',Z)
   [X,Y,Z]=arrow3([0 0 0],[duals(1,3) duals(2,3) duals(3,3)]);
  set(findobj(gcbf,'Tag','target'),'XData',X,'YData',Y,'ZData',Z)
  set(handle,'Color','r','LineWidth',2,'Userdata',num2str(h0))
  set(gca,'XLim',XLim,'YLim',YLim)
  h=findobj(gcbf,'Color',[1 0 0]);
  l=length(h);
    if l>2
     set(findobj(gcbf,'Tag','Axes2'),'Clipping','off')
  end
  

  Eadm('set title')


case 'set title'
      
  h=findobj(gcbf,'Color',[1 0 0]);
  if isempty(h)
      title('','FontSize',12)

      break
   end

  X=get(h(index),'XData');
  Y=get(h(index),'YData');
   
  type=get(h(index),'Tag');
  p=[X(1) Y(1)];
  n=[diff(X(1:2)) diff(Y(1:2))];
  if type=='tangent'
    n=[-n(2) n(1)];
  end
  text=[num2str(n(1),'%1.1f') ' x_1'];
  if n(2)<0
    text=[text ' - '];
  else
    text=[text ' + '];
  end
  texten=[text num2str(abs(n(2)),'%1.1f') ' x_2 = ' num2str(n*p','%1.1f')];
  title(texten,'FontSize',12)
  
  %Update TooltipStrings
  
 set(findobj(gcbf,'Tag','Pushbutton12'),'TooltipString','Solve equations')
    

case 'create'
    
  Eadm('un-current')
  sp=get(gca,'CurrentPoint');
  p=sp(1,1:2);
  n=[0.01 0.01];
  [X,Y]=arrow(p,n);
  h0=line('XData',X,'YData',Y,'Color','b','LineWidth',1);
  set(h0,'Tag',num2str(h0))
  new=line('XData',X,'YData',Y,'Color',[1 0 0],'LineWidth',2,...
       'Tag','tangent','Userdata',num2str(h0),'Visible','off');
  h=findobj(gcbf,'Color',[1 0 0]);
  h=[new; h];
  [m,index]=min(abs(h-new));
  mode='rota';
  set(gcbf,'WindowButtonMotionFcn','Eadm(''move'')')
  set(gcbf,'Tag','WindowButtonUpFcn','Eadm(''stop'')')
  set(gcbf,'WindowButtonDownFcn','Eadm(''start'')')


case 'select'

  Eadm('un-current')
  sp=get(gca,'CurrentPoint');
  sp=sp(1,1:2);
  h=findobj(gcbf,'Color',[1 0 0]);
  index=0;
  dist=100;
  for j=1:length(h)
    X=get(h(j),'XData');
    Y=get(h(j),'YData');
    p=[X(1) Y(1)];
    n=[diff(X(1:2)) diff(Y(1:2))];
    newdist=(X(1)+0.2*n(1)-sp(1))^2+(Y(1)+0.2*n(2)-sp(2))^2;
    if newdist<dist
      index=j; mode='move';
      dist=newdist;
    end
    newdist=(X(2)-0.1*n(1)-sp(1))^2+(Y(2)-0.1*n(2)-sp(2))^2;
    if newdist<dist
      index=j; mode='rota';
      dist=newdist;
    end
  end
  set(h(index),'LineWidth',2)
  Eadm('set title')


case 'start'

  Eadm('select')
  set(gcbf, 'WindowButtonMotionFcn','Eadm(''move'')');
  set(gcbf, 'WindowButtonUpFcn',    'Eadm(''stop'')');
  

case 'move'
  axes(findobj(gcf,'Tag','Axes1'))
  cp=get(gca,'CurrentPoint');
  cp=cp(1,1:2);
  h=findobj(gcbf,'Type','line','Color',[1 0 0]);
  type=get(h(index),'Tag');
  h0=get(h(index),'Userdata');
  X=get(h(index),'XData');
  Y=get(h(index),'YData');
  XLim=get(gca,'XLim');
  YLim=get(gca,'YLim');
  
  if cp(1)>XLim(2)|cp(1)<XLim(1)|cp(2)>YLim(2)|cp(2)<YLim(1)
     break
     end
   
   
   if mode=='move'
    p=cp;
    if type=='normal '
      n=[diff(X(1:2)) diff(Y(1:2))];
      [X,Y]=arrow(p,n);
      v=[n(2) -n(1)];
      duals(index,1:2)=n;
      duals(index,3)=p*n';
    elseif type=='tangent'
      v=[diff(X(1:2)) diff(Y(1:2))];
      [X,Y]=arrow(p,v);
      n=[-v(2) v(1)];
      duals(index,1:2)=n;
      duals(index,3)=p*n';
    end
    Xl=[p(1)-10*v(1) p(1)+10*v(1)];
    Yl=[p(2)-10*v(2) p(2)+10*v(2)];
    set(findobj(gcbf,'Tag',h0),'XData',Xl,'YData',Yl)
    set(h(index),'XData',X,'YData',Y)
  else
    p=[X(1) Y(1)];
    X(2)=cp(1);
    Y(2)=cp(2);
    if type=='normal '
      n=[X(2)-X(1) Y(2)-Y(1)];
      v=[n(2) -n(1)];
      [X,Y]=arrow(p,n);
      duals(index,1:2)=n;
      duals(index,3)=p*n';
    elseif type=='tangent'
      v=[X(2)-X(1) Y(2)-Y(1)];
      [X,Y]=arrow(p,v);
      n=[-v(2) v(1)];
      duals(index,1:2)=n;
      duals(index,3)=p*n';
    end
    Xl=[p(1)-10*v(1) p(1)+10*v(1)];
    Yl=[p(2)-10*v(2) p(2)+10*v(2)];
    set(findobj(gcbf,'Tag',h0),'XData',Xl,'YData',Yl)
    set(h(index),'XData',X,'YData',Y)
  end
  Eadm('set title')
  %Eadm('update formulas')
  %Eadm('show formulas')
  Eadm('solve eqs')
  %Eadm('update kolumn space')


case 'lines off'

  h=findobj(gcbf,'Color',[1 0 0]);
  for j=1:length(h)
    h0=get(h(j),'Userdata');
    set(findobj(gcbf,'Tag',h0),'Visible','off')
    set(h(j),'Visible','off')
  end
  set(findobj(gcbf,'Tag','coords'),'Visible','off')
  set(findobj(gcbf,'Tag','solution'),'Visible','off')
  set(findobj(gcbf,'Tag','LS'),'Visible','off')


case 'lines on'

  h=findobj(gcbf,'Color',[1 0 0]);
  for j=1:length(h)
    h0=get(h(j),'Userdata');
    set(findobj(gcbf,'Tag',h0),'Visible','on')
%    set(h(j),'Visible','off')
  end


case 'stop'

  set(gcbf, 'WindowButtonMotionFcn', '');
  set(gcbf, 'WindowButtonDownFcn', 'Eadm(''start'')');
  set(gcbf, 'WindowButtonUpFcn', '');
  set(gca,'ButtonDownFcn','Eadm(''start'')')
  set(findobj(gcbf,'Tag','x1 guide'),'Visible','off')
  set(findobj(gcbf,'Tag','x2 guide'),'Visible','off')
%  set(findobj(gcbf,'Tag','coords'),'Visible','off')
  Eadm('update formulas') 
  Eadm('show formulas')
%  Eadm('solve eqs')
 % Eadm('update kolumn space') 
%  Eadm('lines on')


case 'shift handle'

  type=get(gco,'String');
  if type=='normal '
    set(gco,'String','tangent')
    h=findobj(gcbf,'Color',[1 0 0],'LineWidth',2,'Tag','tangent');
    for i=1:length(h)
      XData=get(h(i),'XData');
      YData=get(h(i),'YData');
      p=[XData(1) YData(1)];
      v=[diff(XData(1:2)) diff(YData(1:2))];
      n=[-v(2) v(1)];
      [X,Y]=arrow(p,n);
      set(h(i),'XData',X,'YData',Y,'Tag','normal ')
    end
  elseif type=='tangent'
    set(gco,'String','normal ')
    h=findobj(gcbf,'Color',[1 0 0],'LineWidth',2,'Tag','normal ');
    for i=1:length(h)
     XData=get(h(i),'XData');
      YData=get(h(i),'YData');
      p=[XData(1) YData(1)];
      n=[diff(XData(1:2)) diff(YData(1:2))];
      v=[n(2) -n(1)];
      [X,Y]=arrow(p,v);
      set(h(i),'XData',X,'YData',Y,'Tag','tangent')
    end
  end


case 'handles'

  str=get(findobj(gcbf,'Tag','handles'),'String');
  h=findobj(gcbf,'Color',[1 0 0]);
  if str=='handles on '
    set(h,'Visible','on')
    set(gco,'String','handles off')
  else
    set(h,'Visible','off')
    set(gco,'String','handles on ')
  end


case 'delete'

  h=findobj(gcbf,'Color',[1 0 0],'LineWidth',2);
  h0=get(h,'Userdata');
  delete(findobj(gcbf,'Tag',h0))
  delete(h)
  h=findobj(gcbf,'Color',[1 0 0]);
  l=length(h);
    if l<=2
     set(findobj(gcbf,'Tag','Axes2'),'Clipping','on')
  end
  
  index=1;
  if ~isempty(h)
    set(h(1),'LineWidth',2)
 else
    Eadm('clear')
    disp('hej')
    break
 end
 
  set(findobj(gcbf,'Tag','solution'),'Visible','off')
  set(findobj(gcbf,'Tag','LS'),'Visible','off')
  set(findobj(gcbf,'Tag','coords'),'Visible','off')
  %Eadm('set title')
Eadm('set title')
  Eadm('update formulas')
  Eadm('show formulas')
  Eadm('solve eqs')
  Eadm('update kolumn space')

  %  Eadm('LS')


case 'clear'

  h=findobj(gcbf,'Color',[1 0 0]);
  delete(h)
  h=findobj(gcbf,'Color',[0 0 1]);
  delete(h)
  h=findobj(gcbf,'Tag','eq1');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','eq2');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','eq3');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','kol1');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','kol2');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','kol3');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','x1');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','x2');
  set(h,'Visible','off')
  eqs=[0 0 0;0 0 0;0 0 0];
  h=findobj(gcbf,'Tag','LS');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','coords');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','Axes1');
  axes(h)
  title('')
  h=findobj(gcbf,'Tag','k1');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','k2');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','k3');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','lin comb');
  set(h,'Visible','off')
  h=findobj(gcbf,'Tag','guide line');
  set(h,'Visible','off')
  
   set(findobj(gcbf,'Tag','Pushbutton12'),'TooltipString','Add line first')
    


case 'un-current'

  h=findobj(gcbf,'LineWidth',2);
  set(h,'LineWidth',1)


case 'zoom out'
  
  h=findobj(gcbf,'Tag','Axes1');
  XLim=get(h,'XLim');
  YLim=get(h,'YLim');
  set(h,'XLim',XLim*2,'YLim',YLim*2)
  h=findobj(gcbf,'Tag','x1-axis');
  set(h,'XData',XLim*2)
  h=findobj(gcbf,'Tag','x2-axis');
  set(h,'YData',YLim*2)
  h=findobj(gcbf,'Color',[0 0 1]);
  for i=1:length(h)
    X=get(h(i),'XData');
    X=[X(1)-diff(X)/2 X(2)+diff(X)/2];
    Y=get(h(i),'YData');
    Y=[Y(1)-diff(Y)/2 Y(2)+diff(Y)/2];
    set(h(i),'XData',X,'YData',Y);
  end
  h=findobj(gcbf,'Tag','Axes2');
  XLim=get(h,'XLim');
  YLim=get(h,'YLim');
  ZLim=get(h,'ZLim');
  set(h,'XLim',XLim*2,'YLim',YLim*2,'ZLim',ZLim*2)
  h=findobj(gcbf,'Tag','x-axis');
  set(h,'XData',XLim*2)
  h=findobj(gcbf,'Tag','y-axis');
  set(h,'YData',YLim*2)           
  h=findobj(gcbf,'Tag','z-axis');
  set(h,'ZData',ZLim*2)


case 'zoom in'

  h=findobj(gcbf,'Tag','Axes1');
  XLim=get(h,'XLim');
  YLim=get(h,'YLim');
  set(h,'XLim',XLim/2,'YLim',YLim/2)
  h=findobj(gcbf,'Tag','Axes2');
  XLim=get(h,'XLim');
  YLim=get(h,'YLim');
  ZLim=get(h,'ZLim');
  set(h,'XLim',XLim/2,'YLim',YLim/2,'ZLim',ZLim/2)


end





function [X,Y]=arrow(p,n)

  v=[n(2) -n(1)];
  XLim=get(findobj(gcbf,'Tag','Axes1'),'XLim');
  dv=0.015*diff(XLim)*v/norm(v);
  dn=0.03*diff(XLim)*n/norm(n);
  X=[p(1) p(1)+n(1) p(1)+n(1)-dn(1)-dv(1) ...
          p(1)+n(1)-dn(1)+dv(1) p(1)+n(1)];
  Y=[p(2) p(2)+n(2) p(2)+n(2)-dn(2)-dv(2) ...
          p(2)+n(2)-dn(2)+dv(2) p(2)+n(2)];


function [X,Y,Z]=arrow3(p,n)

  if length(n)==2
    n=[n 0];
  end
  w=get(findobj(gcbf,'Tag','Axes2'),'CameraPosition');
  w=w/norm(w);
  v=cross(n,w);
  dv=0.05*norm(n)*v/(norm(v)+0.0001);
  dn=0.1*norm(n)*n/(norm(n)+0.0001);
  X=[p(1) p(1)+n(1) p(1)+n(1)-dn(1)-dv(1) ...
          p(1)+n(1)-dn(1)+dv(1) p(1)+n(1)];
  Y=[p(2) p(2)+n(2) p(2)+n(2)-dn(2)-dv(2) ...
          p(2)+n(2)-dn(2)+dv(2) p(2)+n(2)];
  Z=[p(3) p(3)+n(3) p(3)+n(3)-dn(3)-dv(3) ...
          p(3)+n(3)-dn(3)+dv(3) p(3)+n(3)];


function dummy()



  text=get(findobj(gcf,'Tag','Pushbutton4'),'String');
  if text=='show axis'
    set(findobj(gcf,'Tag','Pushbutton4'),'String','hide axis')
    set(findobj(gcf,'Tag','coordaxis'),'Visible','on')
  elseif text=='hide axis'
    set(findobj(gcf,'Tag','Pushbutton4'),'String','show axis')
    set(findobj(gcf,'Tag','coordaxis'),'Visible','off')
  end














