function GGR22R2_adm(action)

global scale cp


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GGR22R2_adm('update graphics')
   
   
case 'my fcn'
   GGR22R2_adm('update graphics')
   
   
case 'plot type'
   htype=findobj(gcbf,'Tag','plot type');
   type=get(htype,'String');
   if     type=='two graphs'
      h=findobj(gcbf,'Tag','original');
      set(h,'Visible','off')
      h=findobj(gcbf,'Tag','mapped');
      set(h,'Visible','off')
      view(3)
      h1=findobj(gcbf,'Tag','z=u(x,y)');
      h2=findobj(gcbf,'Tag','z=v(x,y)');
      set(h1,'Visible','on')
      set(h2,'Visible','on')
      set(htype,'String','  arrows  ')
   elseif type=='  arrows  '
      h1=findobj(gcbf,'Tag','z=u(x,y)');
      h2=findobj(gcbf,'Tag','z=v(x,y)');
      set(h1,'Visible','off')
      set(h2,'Visible','off')
      h=findobj(gcbf,'Tag','quiver');
      set(h,'Visible','on')
      view(2)
      
      set(htype,'String','two meshes')
   elseif type=='two meshes'
      h=findobj(gcbf,'Tag','quiver');
      set(h,'Visible','off')
      h=findobj(gcbf,'Tag','mapped');
      set(h,'Visible','on')
      h=findobj(gcbf,'Tag','original');
      set(h,'Visible','on')
      set(htype,'String','two graphs')
   end
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hl=findobj(gcbf,'Tag','l');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   l=eval(get(hl,'String'));
%   x=XLim(1):diff(XLim)/20:XLim(2);
%   y=YLim(1):diff(YLim)/20:YLim(2);
x=-1:2/20:1;
y=-1:2/20:1;
   [x,y]=meshgrid(x,y);
   
   %   R=min(XLim(2),YLim(2));
%   r=[0:R/10:R];
%   v=[0:2*pi/40:2*pi];
%   [r,v]=meshgrid(r,v);
%   x=r.*cos(v);
%   y=r.*sin(v);

hu=findobj(gcbf,'Tag','u');
hv=findobj(gcbf,'Tag','v');
uxy=get(hu,'String');
vxy=get(hv,'String');
u=eval(uxy).*ones(size(x));
v=eval(vxy).*ones(size(x));
hu=findobj(gcbf,'Tag','z=u(x,y)');
hv=findobj(gcbf,'Tag','z=v(x,y)');
set(hu,'XData',x,'YData',y,'ZData',u)
set(hv,'XData',x,'Ydata',y,'ZData',v)

  
   hq=findobj(gcbf,'Tag','quiver');
   delete(hq)
   hq=quiver(x,y,u,v);
   set(hq,'Tag','quiver','Color',[1 0 1])
   h=findobj(gcbf,'Tag','plot type');
   str=get(h,'String');
   if str=='two meshes'
   else
      set(hq,'Visible','off')
   end
   
   
   set(gca,'ZLim',ZLim)
   
   h=findobj(gcbf,'Tag','mapped');
   set(h,'XData',x+u,'YData',y+v,'ZData',0*x)
   h=findobj(gcbf,'Tag','original');
   set(h,'XData',x,'YData',y,'ZData',0*x)
   
   rotate3d on
   
   title(['u = ' uxy '  and  ' 'v = ' vxy])
      
   
case 'a'
   GGR22R2_adm('update graphics')
   
   
case 'k'
   GGR22R2_adm('update graphics')
   
   
case 'm'
   GGR22R2_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GGR22R2_adm('update graphics')
   
   
case 'k slider'
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k*10;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   GGR22R2_adm('update graphics')
   
   
case 'l slider'
   hl=findobj(gcbf,'Tag','l slider');
   l=get(hl,'Value');
   l=l*10;
   hl=findobj(gcbf,'Tag','l');
   set(hl,'String',num2str(l,'%1.1f'))
   GGR22R2_adm('update graphics')
   
   
case 'm slider'
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m*10;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   GGR22R2_adm('update graphics')
   
   
case 'zoom in'
   scale=.9;
   GGR22R2_adm('set axis')
   
   
case 'zoom out'
   scale=1.1;
   GGR22R2_adm('set axis')

   
case 'mesh'
   hm=findobj(gcbf,'Tag','mesh');
   if get(hm,'String')=='mesh on '
      h=findobj(gcbf,'Tag','z=u(x,y)');
      set(h,'EdgeColor',[0 0 0])
      h=findobj(gcbf,'Tag','z=v(x,y)');
      set(h,'EdgeColor',[0 0 0])
      set(hm,'String','mesh off')
   elseif get(hm,'String')=='mesh off'
      h=findobj(gcbf,'Tag','z=u(x,y)');
      set(h,'EdgeColor','none')
      h=findobj(gcbf,'Tag','z=v(x,y)');
      set(h,'EdgeColor','none')
      set(hm,'String','mesh on ')
   end
   
   
case 'light'
   hm=findobj(gcbf,'Tag','light knob');
   if get(hm,'String')=='light on '
      h=findobj(gcbf,'Tag','light');
      set(h,'Color',[1 1 1])
      h=findobj(gcbf,'Type','Surface');
      set(h,'FaceLighting','flat')
      set(hm,'String','light off')
   elseif get(hm,'String')=='light off'
      h=findobj(gcbf,'Tag','light');
      set(h,'Color',[0 0 0])
      h=findobj(gcbf,'Type','Surface');
      set(h,'FaceLighting','none')
      set(hm,'String','light on ')
   end
   
   
case 'set axis'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   ZLim=get(gca,'ZLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   dZ=scale*diff(ZLim);
   cp(1)=sum(XLim)/2;
   cp(2)=sum(YLim)/2;
   cp(3)=sum(ZLim)/2;
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   NewZLim=[cp(3)-dZ/2 cp(3)+dZ/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim,'ZLim',NewZLim)
   GGR22R2_adm('update graphics')
   
case 'back'
   close(gcf)
   open('GG2.fig')
   
case 'close'
   close(gcf)
   
end
