function GGlin_adm(action)

global scale cp qw


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GGlin_adm('update graphics')
   
   
case 'my fcn'
   GGlin_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   YLim=get(gca,'YLim');
   x=XLim;
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hm=findobj(gcbf,'Tag','m');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   m=eval(get(hm,'String'));
   
   hg=findobj(gcbf,'Tag','g(x)');
   gx=get(hg,'String');
   hg=findobj(gcbf,'Tag','y=g(x)');
   if isempty(gx)
      set(hg,'Visible','off')
   else
      x=XLim(1):dx/100:XLim(2);
      g=eval(gx);
      set(hg,'XData',x,'YData',g,'Visible','on')
      x=XLim;
   end
   
   hf=findobj(gcbf,'Tag','f gallery');
   string=get(hf,'String');
   val=get(hf,'Value');
   fx=string{val};
   f=eval(fx).*ones(size(x));
   hg=findobj(gcbf,'Tag','y=f(x)');
   set(hg,'XData',x,'YData',f);
   hx=findobj(gcbf,'Tag','x_axis');
   set(hx,'XData',XLim)
   hy=findobj(gcbf,'Tag','y_axis');
   set(hy,'YData',YLim)
   ha2m=findobj(gcbf,'Tag','a2m');
   x=a;
   f=eval(fx);
   set(ha2m,'XData',[a a 0],'Ydata',[0 f f])
   ha=findobj(gcbf,'Tag','a-text');
   set(ha,'Position',[x-.01*dx -.017*dx*f/(abs(f)+eps)])
   hm=findobj(gcbf,'Tag','m-text');
   set(hm,'Position',[-.03*dx*(.5+x/(abs(x)+eps)) f])
   if val==4
      set(ha,'Visible','on')
      set(hm,'Visible','on')
      set(ha2m,'Visible','on')
   else
      set(ha,'Visible','off')
      set(hm,'Visible','off')
      set(ha2m,'Visible','off')
   end
   set(gca,'XLim',XLim,'YLim',YLim)
   if val==2
     tit=['y = ' num2str(k,'%1.1f')];
   else
     tit=['y = ' num2str(m,'%1.1f')];
     if val>1
       if k>0
         tit=[tit ' + ' num2str(k,'%1.1f')];
       elseif k<0
         tit=[tit ' - ' num2str(abs(k),'%1.1f')];
       end
     end
   end
   if ~k==0 & val>1
     if val==4
       if a>0
          tit=[tit '*(x-' num2str(a,'%1.1f') ')'];
       elseif a<0
          tit=[tit '*(x+' num2str(abs(a),'%1.1f') ')'];
       else
          tit=[tit '*x'];
       end      
     else
       tit=[tit '*x'];
     end
   end
   title(tit)
      
   
case 'a'
   GGlin_adm('update graphics')
   
   
case 'k'
   GGlin_adm('update graphics')
   
   
case 'm'
   GGlin_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GGlin_adm('update graphics')
   
   
case 'k slider'
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k*10;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   GGlin_adm('update graphics')
   
   
case 'm slider'
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m*10;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   GGlin_adm('update graphics')
   
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','GGlin_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','GGlin_adm(''set axis'')')
   scale=2;
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','GGlin_adm(''set axis'')')
   scale=1;
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   GGlin_adm('update graphics')
   
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','GGlin_adm(''start drag'')')
   
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','GGlin_adm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','GGlin_adm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   GGlin_adm('Update graphics')
   
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   GGlin_adm('update graphics')
   
case 'back'
   close(gcbf)
   open('GG.fig')
   
   
case 'questions'
   if get(gcbo,'String')=='questions'
      set(gcbo,'String',  'close    ')
   elseif get(gcbo,'String')=='close    '
      set(gcbo,'String','questions')
      close(qw)
      return
   end
   qw=figure;
   set(gcf,'Position',get(gcf,'Position')-[300 0 0 0])
   h=findobj(qw,'Tag','figMenuTools');
   set(h,'HandleVisibility','off')
   ht=uicontrol('style','text',...
      'Units','normalized',...
      'Position',[.05 .15 .9 .8],...
      'Tag','text',...
      'HorizontalAlignment','left',...
      'FontSize',12,...
      'FontWeight','demi');
   ht=uicontrol('style','slider',...
      'Units','normalized',...
      'Position',[.05 0.05 .3 .05],...
      'SliderStep',[.1 .2],...
      'Tag','slider',...
      'Callback','GGlin_adm(''roll'')');
   hh=uicontrol('style','pushbutton',...
      'Units','normalized',...
      'Position',[0.6 0.05 .2 .05],...
      'Tag','hide',...
      'String','hide',...
      'Callback','GGlin_adm(''hide'')');
   GGlin_adm('def string')
   GGlin_adm('roll')
   
   
   
case 'hide'
   hf=findobj('Type','axes');
   h=get(hf,'title');
   set(h,'Color',[.8 .8 .8]);
   h=findobj('Tag','a');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj('Tag','k');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj('Tag','m');
   set(h,'ForegroundColor',[1 1 1])
   h=findobj(qw,'String','hide');
   set(h,'String','show','Callback','GGlin_adm(''show'')')
   
   
case 'show'
   hf=findobj('Type','axes');
   h=get(hf,'title');
   set(h,'Color',[0 0 1]);
   h=findobj('Tag','a');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj('Tag','k');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj('Tag','m');
   set(h,'ForegroundColor',[0 0 0])
   h=findobj(qw,'String','show');
   set(h,'String','hide','Callback','GGlin_adm(''hide'')')
   
   
case 'roll'
   ht=findobj(qw,'Tag','text');
   hs=findobj(qw,'Tag','slider');
   val=get(hs,'Value');
   string=get(ht,'UserData');
   l=length(string);
   m=min(l,round(val*30)+1);
   M=min(l,round(val*30)+14);
   set(ht,'String',string(m:M))

      
case 'def string'
string={...
   '  1. If f(x) is something that depends on x,';...
   '      is f(x)=m then really a function?';...
   '';...
   '  2. Where in the graph plot is x=4?';...
   '';...
   '  3. Where is y=m?';...
   '';...
   '  4. Describe the graph y=-2x.';...
   '';...
   '  5. Does f(x)=-2x have the property';...
   '      f(cx)=cf(x) for any constant c?';...
   '';...
   '  6. Does it also have the property';...
   '      f(x_1+x_2)=f(x_1)+f(x_2) for all x_is?';...
   '';...
   '  7. Does f(x)=-2x+1 have these properties?';...
   '';...
   '  8. Which f(x) have the properties in 5 and 6?';...
   '';...
   '  9. Is f(x)=-2x+1 a linear function?';...
   '';...
   '10. Describe the graph y=-2x+1.';...
   '';...
   '11. Describe the graph y=m+k(x-a).';...
   '';...
   '12. Write f(x)=7+3(x-2) as f(x)=m+k(x-a).';...
   '';...
   '13. Write f(x)=2+5x as f(x)=m+k(x-a) with';...
   '     (a) a=2,  (b) m=3,  (c) k=4';...
   '';...
   '14. Can x=3 be wrtitten as y=m+kx?';...
   '';...
   '15. Where does the graph y=m+kx start/end?';...
   '';...
   '16. How would y=-2x+1 look with the direction';...
   '     of the y-axis reversed?';...
   '';...
   '17. How would y=x look with the x-axis rescaled?';...
   '';...
   '18. Hide and find, that is press the hide button,';...
   '     create blue graphs and make red copies!'};
   
   h=findobj(qw,'Tag','text');
   set(h,'UserData',string)

   
   
   
end
