function GGtrig_adm(action)

global scale cp k_vector


switch action
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   GGtrig_adm('update graphics')
   
   
case 'my fcn'
   GGtrig_adm('update graphics')
   
   
case 'update graphics'
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   YLim=get(gca,'YLim');
   x=[XLim(1):dx/100:XLim(2)];
   ha=findobj(gcbf,'Tag','a');
   hk=findobj(gcbf,'Tag','k');
   hm=findobj(gcbf,'Tag','m');
   a=eval(get(ha,'String'));
   k=eval(get(hk,'String'));
   m=eval(get(hm,'String'));
   
   hg=findobj(gcbf,'Tag','g(x)');
   gx=get(hg,'String');
   hg=findobj(gcbf,'Tag','y=g(x)');
   if isempty(gx)
      set(hg,'Visible','off')
   else
      g=eval(gx);
      set(hg,'XData',x,'YData',g,'Visible','on')
   end
   
   hf=findobj(gcbf,'Tag','f gallery');
   string=get(hf,'String');
   val=get(hf,'Value');
   fx=string{val};
   f=eval(fx);
   hg=findobj(gcbf,'Tag','y=f(x)');
   set(hg,'XData',x,'YData',f);
   hx=findobj(gcbf,'Tag','x_axis');
   set(hx,'XData',XLim)
   hy=findobj(gcbf,'Tag','y_axis');
   set(hy,'YData',YLim)
   set(gca,'XLim',XLim,'YLim',YLim)
   M=num2str(m,'%1.0f');
   h=get(gca,'title');
   tit=get(h,'String');
   if a>=0
      A=[num2str(a,'%1.1f')];
   elseif a<0
      A=['-' num2str(abs(a),'%1.1f')];
   end
   if k>=0
      K=[num2str(k,'%1.1f')];
   elseif k<0
      K=[' - ' num2str(abs(k),'%1.1f')];
   end
   M='';
   if m>100*eps
      M=[' + ' num2str(m,'%1.1f')];
   elseif m<-100*eps
      M=[' - ' num2str(abs(m),'%1.1f')];
   end
   tit=['y = ' A];
   if val==1
     tit=[tit ' sin ('];
   elseif val==2
     tit=[tit ' cos ('];
   elseif val==3
      tit=[tit ' tan ('];
   elseif val==4
      tit=[tit ' cot ('];
   elseif val==5
      tit=[tit ' atan ('];
   elseif val==6
      tit=[tit ' sinh ('];
   elseif val==7
      tit=[tit ' cosh ('];
   end
   tit=[tit K 'x' M ')'];
   
   title(tit)
   
   
case 'a'
   GGtrig_adm('update graphics')
   
   
case 'k'
   GGtrig_adm('update graphics')
   
   
case 'm'
   GGtrig_adm('update graphics')
   
   
case 'a slider'
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a*10;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   GGtrig_adm('update graphics')
   
   
case 'k slider'
   h=findobj(gcbf,'Tag','f gallery');
   val=get(h,'Value');
   if val<=7
      hk=findobj(gcbf,'Tag','k slider');
      k=get(hk,'Value');
      k=k*10;
      hk=findobj(gcbf,'Tag','k');
      set(hk,'String',num2str(k,'%1.1f'))
   else
      h=findobj(gcbf,'Tag','m');
      m=eval(get(h,'String'));
      h=findobj(gcbf,'Tag','k');
      hk=findobj(gcbf,'Tag','k slider');
      k=get(hk,'Value');
      k=k*10;
      k_vector(m+1)=k;
      set(h,'String',num2str(k,'%1.1f'))
   end
   GGtrig_adm('update graphics')
   
   
case 'm slider'
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m*10;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   GGtrig_adm('update graphics')
   
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','GGtrig_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','GGtrig_adm(''set axis'')')
   scale=2;
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','GGtrig_adm(''set axis'')')
   scale=1;
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   GGtrig_adm('update graphics')
   
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','GGtrig_adm(''start drag'')')
   
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','GGtrig_adm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','GGtrig_adm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   GGtrig_adm('Update graphics')
   
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   GGtrig_adm('update graphics')
   
case 'back'
   close(gcbf)
   open('GG.fig')
   
   
end
