function LIN_adm(action)

global scale a m k f select_point h1 h2 h hs

set(gcf,'DoubleBuffer','on','renderer','zbuffer')

switch action


case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','LIN_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','LIN_adm(''set axis'')')
   scale=2;
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   LIN_adm('update')
   
   
case 'slide a'
   
   ha=findobj(gcbf,'Tag','a slider');
   a=get(ha,'Value');
   a=a;
   ha=findobj(gcbf,'Tag','a');
   set(ha,'String',num2str(a,'%1.1f'))
   LIN_adm('update')
   
   
case 'slide m'
   
   hm=findobj(gcbf,'Tag','m slider');
   m=get(hm,'Value');
   m=m;
   hm=findobj(gcbf,'Tag','m');
   set(hm,'String',num2str(m,'%1.1f'))
   LIN_adm('update')
   
   
case 'slide k'
   
   hk=findobj(gcbf,'Tag','k slider');
   k=get(hk,'Value');
   k=k;
   hk=findobj(gcbf,'Tag','k');
   set(hk,'String',num2str(k,'%1.1f'))
   LIN_adm('update')
   
   
case 'choose_fcn'

  value=get(findobj(gcbf,'Tag','f_gallery'),'Value');
  string=get(findobj(gcbf,'Tag','f_gallery'),'String');
  f=string{value};

  set(findobj(gcbf,'Tag','my_fcn'),'String',f)
  LIN_adm('plot_fcn')
  h=findobj(gcbf,'Tag','xtoy1');


case 'plot_fcn'

   delete(findobj(gcbf,'Tag','f_graph'))
   title('')
   f=get(findobj(gcbf,'Tag','my_fcn'),'String');
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=diff(XLim);
   x=XLim(1):dX/100:XLim(2);
   y=eval(f);
   line(x,eval(f),'Color','r','Tag','f_graph')
   axis([x(1) x(length(x)) min(y)-.5 max(y)+.5]);
   set(findobj('Tag','x_axis'),'XData',XLim)
   set(findobj('tag','y_axis'),'Ydata',YLim)
%   LIN_adm('update')
   title('y = f(x)  and  y = m + k (x - a)')
   set(gca,'XLim',XLim,'YLim',YLim)
   
   
case 'update'
   
   a=eval(get(findobj(gcbf,'Tag','a'),'String'));
   m=get(findobj(gcbf,'Tag','m'),'String');
   if length(m)==4 & m=='f(a)'
      f=get(findobj(gcbf,'Tag','my_fcn'),'String');
      x=a;
      m=eval(f);
      tit='y = f(a)';
   elseif length(m)>=2 & m(1:2)=='f('
      f=get(findobj(gcbf,'Tag','my_fcn'),'String');
      x=eval(m(3:length(m)-1));
      m=eval(f);
      tit=['y = f(' num2str(a,'%1.1f') ')'];
   else   
      m=eval(m);
      tit=['y = ' num2str(m,'%1.1f')];
   end
   k=get(findobj(gcbf,'Tag','k'),'String');
   if length(k)==5 & k=='Df(a)'
      fx=get(findobj(gcbf,'Tag','my_fcn'),'String');
      x=a;
      k=eval(fx);
      dx=0.00000001;
      x=x+dx;
      k=(eval(fx)-k)/dx;
      tit=[tit ' + Df(a) (x - a)'];
   elseif length(k)>=3 & k(1:3)=='Df('
      fx=get(findobj(gcbf,'Tag','my_fcn'),'String');
      x=eval(k(4:length(k)-1));
      k=eval(fx);
      dx=0.00000001;
      x=x+dx
      k=(eval(fx)-k)/dx;
      x=x-dx
      tit=[tit ' + Df(' num2str(x,'%1.1f') ') (x - ' num2str(a,'%1.1f') ' )'];
   else
      k=eval(k);
      tit=[tit ' + ' num2str(k,'%1.1f') ' (x - ' num2str(a,'%1.1f') ' )'];
   end
   a2m=findobj(gcbf,'Tag','a2m');
   x=a;
   set(a2m,'XData',[x x 0],'YData',[0 m m])
   XLim=get(gca,'XLim');
   dx=diff(XLim);
   YLim=get(gca,'YLim');
   hx=findobj(gcbf,'Tag','x_axis');
   set(hx,'XData',XLim)
   hy=findobj(gcbf,'Tag','y_axis');
   set(hy,'YData',YLim)
   ha=findobj(gcbf,'Tag','a-text');
   set(ha,'Position',[x-.01*dx -.017*dx*m/(abs(m)+eps)])
   hm=findobj(gcbf,'Tag','m-text');
   set(hm,'Position',[-.03*dx*(.5+x/(abs(x)+eps)) m])
   LIN_adm('plot_fcn')
   xl=XLim(1);
   xr=XLim(2);
   yl=m+k*(xl-a);
   yr=m+k*(xr-a);
   l=findobj(gcbf,'Tag','lin_approx');
   set(l,'XData',XLim,'YData',[yl yr])
   title(['y = f(x)  and  ' tit])
   
   
case 'BDF'
   
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2);
   h1=findobj('Tag','xtoy1');
   h2=findobj('Tag','xtoy2');
   XData1=get(h1,'XData');
   XData2=get(h2,'XData');
   X1=XData1(1);
   X2=XData2(1);
   if abs(cp(1)-X1)<abs(cp(1)-X2) h=h1; hs=h2; else h=h2; hs=h1; end
   set(gcf,'WindowButtonMotionFcn','LIN_adm(''WBMF'')')
   set(gcf,'WindowButtonUpFcn','LIN_adm(''WBUF'')')
   
   
case 'WBMF'
   
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2);
   x=cp(1);
   fx=get(findobj('Tag','my_fcn'),'String');
   y=eval(fx);
   % y=sin(5*x);
   XData=[x x 0];
   YData=[0 y y];
   set(h,'XData',XData,'YData',YData);
   XData=get(hs,'XData');
   YData=get(hs,'YData');
   dx=XData(1)-x;
   dy=YData(3)-y;
   if dx==0 L='???'; else
      L=num2str(abs(dy)/abs(dx),'%2.1f');
   end
   text=['| f(x_2) - f(x_1) | = ' L ' | x_2 - x_1 |'];
   title(text)
   set(findobj(gcbf,'Tag','x_gap'),'XData',[x x+dx],'YData',[0 0])
   set(findobj(gcbf,'Tag','y_gap'),'YData',[y y+dy],'XData',[0 0])
   if h==h1
      hx=findobj('String','x_1');
      hfx=findobj('String','f(x_1)');
   else
      hx=findobj('String','x_2');
      hfx=findobj('String','f(x_2)');
   end
   if y>0
      hxpos=[x-0.02 -.1];
   else
      hxpos=[x-.02 +.1];
   end
   set(hx,'Position',hxpos)
   if x>0
      hfxpos=[-.13 y-.03];
   else
      hfxpos=[.03 y-.03];
   end
   set(hfx,'Position',hfxpos)
   
   
case 'WBUF'
   set(gcf,'WindowButtonMotionFcn','')
   set(gcf,'WindowButtonUpFcn','')
   
   
case 'move_a'

  sp=get(findobj(gcbf,'Tag','Fig1'),'Userdata');
  old_a=sp(1,1);
  pos=get(gca,'CurrentPoint');
  a=pos(1,1);
  a=old_a+0.6*(a-old_a);
  set(findobj(gcbf,'Tag','a'),'String',num2str(a))
  Lip_adm('taylor')
  YData=get(findobj(gcbf,'Tag','polynomial'),'YData');
  y=YData(51);


case 'close'
   close(gcf)

end


