function LIP_adm(action)

global scale cp qw select_point h1 h2 h hs
set(gcf,'renderer','zbuffer')

% disp('The new Lip_adm!!')

switch action

case 'update graphics'
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dx=diff(XLim);
   hf=findobj(gcbf,'Tag','my_fcn');
   fx=get(hf,'String');
   h1=findobj(gcbf,'Tag','x1');
   x=eval(get(h1,'String'));
   y1=eval(fx);
   x1=x;
   h2=findobj(gcbf,'Tag','x2');
   x=eval(get(h2,'String'));
   y2=eval(fx);
   x2=x;
   
   h1=findobj(gcbf,'Tag','x1-text');
   set(h1,'String','x_1','Position',[x1-.01*dx -.017*dx*y1/(abs(y1)+eps)])
   h=findobj(gcbf,'Tag','y1-text');
   set(h,'String','f(x_1)','Position',[-.06*dx*(.8+x1/(abs(x1)+eps)) y1])
   
   h2=findobj(gcbf,'Tag','x2-text');
   set(h2,'String','x_2','Position',[x2-.01*dx -.017*dx*y2/(abs(y2)+eps)])
   h=findobj(gcbf,'Tag','y2-text');
   set(h,'String','f(x_2)','Position',[-.06*dx*(.8+x2/(abs(x2)+eps)) y2])
   
   ha2m=findobj(gcbf,'Tag','x12y1');
   set(ha2m,'XData',[x1 x1 0],'Ydata',[0 y1 y1])
   
   ha2m=findobj(gcbf,'Tag','x22y2');
   set(ha2m,'XData',[x2 x2 0],'Ydata',[0 y2 y2])
   
   x=min(x1,x2); dx=max(x1,x2)-x;
   set(findobj(gcbf,'Tag','x_gap'),'XData',[x x+dx],'YData',[0 0])
   y=min(y1,y2); dy=max(y1,y2)-y;
   set(findobj(gcbf,'Tag','y_gap'),'YData',[y y+dy],'XData',[0 0])
   
   if dx==0 L='???'; else
      L=num2str(abs(dy)/abs(dx),'%2.1f');
   end
   text=['| f(x_2) - f(x_1) | = ' L ' | x_2 - x_1 |'];
   title(text)
   
   h=findobj(gcbf,'Tag','Df');
   Df=get(h,'String');
   Df=eval(Df);
   dx=diff(Df);
   x=Df(1):dx/100:Df(2);
   f=eval(fx);
   h=findobj(gcbf,'Tag','y=f(x)');
   set(h,'XData',x,'YData',f)
   
   h=findobj(gcbf,'Tag','x_axis');
   set(h,'XData',XLim)
   h=findobj(gcbf,'Tag','y_axis');
   set(h,'YData',YLim)
%   title(tit)
   
   
case 'Df'
   h=findobj(gcbf,'Tag','Df');
   Df=get(h,'String');
   Df=eval(Df);
   h=findobj(gcbf,'Tag','x1 slider');
   set(h,'Min',Df(1),'Max',Df(2),'SliderStep',[0.02 0.03])
   h=findobj(gcbf,'Tag','x2 slider');
   set(h,'Min',Df(1),'Max',Df(2),'SliderStep',[0.02 0.03])
   
   
case 'f gallery'
   h=findobj(gcbf,'Tag','f gallery');
   string=get(h,'String');
   val=get(h,'Value');
   title(['y = ' string{val}])
   h=findobj(gcbf,'Tag','my_fcn');
   set(h,'String',string{val})
   LIP_adm('update graphics')
   

case 'x1'
   LIP_adm('update graphics')
   
   
case 'x2'
   LIP_adm('update graphics')
   
   
case 'x1 slider'
   h=findobj(gcbf,'Tag','x1 slider');
   x1=get(h,'Value');
   h=findobj(gcbf,'Tag','x1');
   set(h,'String',num2str(x1,'%1.2f'))
   LIP_adm('update graphics')
   
   
case 'x2 slider'
   h=findobj(gcbf,'Tag','x2 slider');
   x2=get(h,'Value');
   h=findobj(gcbf,'Tag','x2');
   set(h,'String',num2str(x2,'%1.2f'))
   LIP_adm('update graphics')
   
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','LIP_adm(''set axis'')')
   scale=.75;
   set(gcbf,'WindowButtonUpFcn','set(gcf,''WindowButtonDownFcn'',''LIP_adm(''''BDF'''')'')')
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','LIP_adm(''set axis'')')
   scale=1.5;
   set(gcbf,'WindowButtonUpFcn','set(gcf,''WindowButtonDownFcn'',''LIP_adm(''''BDF'''')'')')
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','LIP_adm(''set axis'')')
   scale=1;
   set(gcbf,'WindowButtonUpFcn','set(gcf,''WindowButtonDownFcn'',''LIP_adm(''''BDF'''')'')')
   
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   LIP_adm('update graphics')
   
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','LIP_adm(''start drag'')')
   
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','LIP_adm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','LIP_adm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   LIP_adm('Update graphics')
   
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   LIP_adm('update graphics')
   set(gcbf,'WindowButtonDownFcn','set(gcf,''WindowButtonDownFcn'',''LIP_adm(''''BDF'''')'')')
   
   
case 'close'
   close(gcf)
   
   
case 'questions'
   disp('To appear')
   
   
case 'BDF'
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2);
   h1=findobj('Tag','x12y1');
   h2=findobj('Tag','x22y2');
   XData1=get(h1,'XData');
   XData2=get(h2,'XData');
   X1=XData1(1);
   X2=XData2(1);
   if abs(cp(1)-X1)<abs(cp(1)-X2) hs=findobj(gcbf,'Tag','x1'); else hs=findobj(gcbf,'Tag','x2'); end
   set(gcf,'WindowButtonMotionFcn','Lip_adm(''WBMF'')')
   set(gcf,'WindowButtonUpFcn','Lip_adm(''WBUF'')')
   
   
case 'WBMF'
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2);
   x=cp(1);
   h=findobj(gcbf,'Tag','Df');
   str=eval(get(h,'String'));
   if str(1)<=x & x<=str(2)
      set(hs,'String',num2str(x));
   end
   LIP_adm('update graphics')
   
   
case 'WBMF_old'
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2);
   x=cp(1);
   fx=get(findobj('Tag','my_fcn'),'String');
   y=eval(fx);
   % y=sin(5*x);
   XData=[x x 0];
   YData=[0 y y];
   set(h,'XData',XData,'YData',YData);
   XData=get(hs,'XData');
   YData=get(hs,'YData');
   dx=XData(1)-x;
   dy=YData(3)-y;
   if dx==0 L='???'; else
      L=num2str(abs(dy)/abs(dx),'%2.1f');
   end
   text=['| f(x_2) - f(x_1) | = ' L ' | x_2 - x_1 |'];
   title(text)
   set(findobj(gcbf,'Tag','x_gap'),'XData',[x x+dx],'YData',[0 0])
   set(findobj(gcbf,'Tag','y_gap'),'YData',[y y+dy],'XData',[0 0])
   if h==h1
      hx=findobj('String','x_1');
      hfx=findobj('String','f(x_1)');
   else
      hx=findobj('String','x_2');
      hfx=findobj('String','f(x_2)');
   end
   if y>0
      hxpos=[x-0.02 -.1];
   else
      hxpos=[x-.02 +.1];
   end
   set(hx,'Position',hxpos)
   if x>0
      hfxpos=[-.13 y-.03];
   else
      hfxpos=[.03 y-.03];
   end
   set(hfx,'Position',hfxpos)
   
   
case 'WBUF'
   set(gcf,'WindowButtonMotionFcn','')
   set(gcf,'WindowButtonUpFcn','')
   



end


