function MMLadm(action)

global springs dashpots nodes velos index rforce free

set(0,'RecursionLimit',1000)

switch action
   
   
case 'clear'
   nodes=[];
   velos=[];
   springs=[];
   dashpots=[];
   cla
   set(gca,'ButtonDownFcn','')
   
   
case 'add node'
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   nodes=[nodes [cp;1;0]];
   velos=[velos [0; 0]];
   pat(nodes)
   
   
case 'cut node'
   index=get_node(nodes);
   nodes=[nodes(:,1:index-1) nodes(:,index+1:size(nodes,2))];
   velos=[velos(:,1:index-1) velos(:,index+1:size(velos,2))];
   pat(nodes)
   
   
case 'move node'
   index=get_node(nodes);
   nodes(4,index)=1;
   velos(:,index)=[0;0];
   velos=0*velos;
   set(gcbf,'WindowButtonMotionFcn','MMLadm(''drag node'')')
   set(gcbf,'WindowButtonUpFcn','MMLadm(''drop node'')')


case 'drag node'
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   h=findobj(gcbf,'Tag',num2str(index));
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   if XLim(1)<cp(1) & cp(1)<XLim(2) & YLim(1)<cp(2) & cp(2)<YLim(2)
      nodes(1:2,index)=cp;
      x=get(h,'XData'); x=x-mean(x);
      y=get(h,'YData'); y=y-mean(y);
      set(h,'XData',x+cp(1),'YData',y+cp(2))
      MMLadm('nature')
   end
   
   
case 'drop node'
   h=findobj(gcbf,'Tag',num2str(index));
   if get(h,'FaceColor')==[0 0 1]
      nodes(4,index)=0;
   end
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   set(gca,'ButtonDownFcn','MMLadm(''on-off'')')
   MMLadm('nature')
   
   
case 'incr mass'
   index=get_node(nodes);
   nodes(3,index)=nodes(3,index)*2;
   pat(nodes)
   
   
case 'decr mass'
   index=get_node(nodes);
   nodes(3,index)=nodes(3,index)/2;
   pat(nodes)
   
   
case 'fix node'
   index=get_node(nodes);
   nodes(4,index)=1;
   pat(nodes)


case 'free node'
   index=get_node(nodes);
   nodes(4,index)=0;
   pat(nodes)

   
case 'add spring'
   index=get_node(nodes);
   springs=[springs [index;0;0;1]];
   set(gcbf,'WindowButtonDownFcn','MMLadm(''hookup'')')
   
   
case 'hookup'
   index=get_node(nodes);
   springs(2,size(springs,2))=index;
   fi=springs(1,size(springs,2));
   l=norm(nodes(1:2,fi)-nodes(1:2,index));
   springs(3,size(springs,2))=l;
   if fi==index springs=springs(:,size(springs,2)); end
   MMLadm('spring update')
   set(gcbf,'WindowButtonDownFcn','MMLadm(''add spring'')')
  
   
case 'cut spring'
   index=get_spring(nodes,springs);
   springs=[springs(:,1:index-1) springs(:,index+1:size(springs,2))];
   MMLadm('spring update')
   
   
case 'incr stiffn'
   index=get_spring(nodes,springs);
   springs(4,index)=springs(4,index)*2;
   pat(nodes)
   MMLadm('spring update')
   
   
case 'decr stiffn'
   index=get_spring(nodes,springs);
   springs(4,index)=springs(4,index)/2;
   pat(nodes)
   MMLadm('spring update')

   
case 'incr length'
   index=get_spring(nodes,springs);
   springs(3,index)=springs(3,index)*2;
   pat(nodes)
   MMladm('spring update')
   
   
case 'decr length'
   index=get_spring(nodes,springs);
   springs(3,index)=springs(3,index)/2;
   pat(nodes)
   MMLadm('spring update')
  
   
%%%%%%%%%%%

case 'add dashpot'
   index=get_node(nodes);
   dashpots=[dashpots [index;0;0;1]];
   set(gcbf,'WindowButtonDownFcn','MMLadm(''d-hookup'')')
   
   
case 'd-hookup'
   index=get_node(nodes);
   dashpots(2,size(dashpots,2))=index;
   fi=dashpots(1,size(dashpots,2));
   l=norm(nodes(1:2,fi)-nodes(1:2,index));
   dashpots(3,size(dashpots,2))=l;
   if fi==index dashpots=dashpots(:,size(dashpots,2)); end
   MMLadm('dashpot update')
   set(gcbf,'WindowButtonDownFcn','MMLadm(''add dashpot'')')
  
   
case 'cut dashpot'
   index=get_dashpot(nodes,dashpots);
   dashpots=[dashpots(:,1:index-1) dashpots(:,index+1:size(dashpots,2))];
   MMLadm('dashpot update')
   
   
case 'incr d-stiffn'
   index=get_dashpot(nodes,dashpots);
   dashpots(4,index)=dashpots(4,index)*2;
   pat(nodes)
   MMLadm('dashpot update')
   
   
case 'decr d-stiffn'
   index=get_dashpot(nodes,dashpots);
   dashpots(4,index)=dashpots(4,index)/2;
   pat(nodes)
   MMLadm('dashpot update')

   
case 'incr d-length'
   index=get_dashpot(nodes,dashpots);
   dashpots(3,index)=dashpots(3,index)*2;
   pat(nodes)
   MMladm('dashpot update')
   
   
case 'decr d-length'
   index=get_dashpot(nodes,dashpots);
   dashpots(3,index)=dashpots(3,index)/2;
   pat(nodes)
   MMLadm('dashpot update')
  
  %%%%%%%%%
  
case 'add struct'
   disp('hello')
   value=get(findobj(gcbf,'Tag','struct menu'),'Value');
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   newnodes=[cp;1;0];
   if value==2
     dx=[.4;0]; dy=[0; -.4];
     newnodes=[cp cp+dx cp+2*dx cp+dy cp+dx+dy cp+2*dx+dy;...
               1 1 1 1 1 1;0 0 0 0 0 0];
     l=size(nodes,2);
     d=.4; s=sqrt(2)*d;
     newsprings=[1 2 4 5 1 2 3 1 2 2 3;...
                 2 3 5 6 4 5 6 5 6 4 5;...
                 d d d d d d d s s s s;...
                 1 1 1 1 1 1 1 1 1 1 1];
     newsprings=newsprings+l;
     springs=[springs newsprings];
     nodes=[nodes newnodes];
   elseif value==3
     disp('to appear')
   end
   pat(nodes)
   MMLadm('spring update')
   set(gcbf,'WindowButtonDownFcn','')   
      

case 'on-off'
   h=findobj(gcbf,'Tag','nature');
   s=get(h,'String');
   if s=='on '
      set(h,'String','off')
      return
   elseif s=='off'
      set(h,'String','on ')
      MMLadm('nature')
   end
   
   
case 'configure'
   x0=nodes(1,index); y0=nodes(2,index);
   line([x0 x0+rforce(1)],[y0 y0+rforce(2)],'LineWidth',3)
   set(gca,'XLim',[0 1],'YLim',[0 1])
   
   
case 'slide friction'
   h=findobj(gcbf,'Tag','friction slider');
   val=get(h,'Value');
   h=findobj(gcbf,'Tag','friction');
   set(h,'String',num2str(val))
   
   
case 'nature'
   if isempty(velos)
      velos=0*nodes(1:2,:)
   end
   free=(nodes(4,:)==0);
   free=[free;free];
   dt=.4;
   sf=spring_forces(nodes,springs);
   df=dashpot_forces(nodes,dashpots,velos);
   if isempty(df)
      df=0*sf;
   end
   gf=gravity_forces(nodes);
   ff=friction_forces(velos);
   force=sf+df+gf+ff;
   dv=force*dt;
   v=velos+dv.*free;
   dn=velos*dt+[force(1,:)./nodes(3,:);force(2,:)./nodes(3,:)]*dt*dt/2;
   n=nodes(1:2,:)+dn.*free;
   res=1;
   while res>0.001
      sf=spring_forces(n,springs);
      df=dashpot_forces(n,dashpots,v);
      if isempty(df)
         df=0*sf;
      end
      gf=gravity_forces([n;nodes(2:3,:)]);
      ff=friction_forces(v);
      f=sf+df+gf+ff;
      dnv=-[n-nodes(1:2,:)-dt/2*(v+velos) v-velos-dt/2*(f+force)];
      nv=[n v]+dnv.*[free free];
      n=nv(1:2,1:size(nodes,2));
      v=nv(1:2,size(nodes,2)+1:size(nv,2));
      res=max(max(abs(dnv.*[free free])));
   end
   dn=n-nodes(1:2,:);
   dv=v-velos;
   nodes(1:2,:)=n;
   velos=v;
   for i=1:size(nodes,2)
      h=findobj(gcbf,'Tag',num2str(i));
      x=get(h,'XData'); x=x-mean(x);
      y=get(h,'YData'); y=y-mean(y);
      set(h,'XData',x+nodes(1,i),'YData',y+nodes(2,i))
   end
   MMLadm('spring update')
   MMLadm('dashpot update')
   drawnow
   m=max(max(max(abs(dn.*free))),max(max(abs(dv.*free))));
   if m<0.001 | get(findobj(gcbf,'Tag','nature'),'String')=='off'
%      disp('Has come to rest')
      return
   end
   MMLadm('nature')
             
   
   
case 'spring update'
   h=findobj('Type','line','Tag','spring');
   delete(h)
   for i=1:size(springs,2)
      x=nodes(1,springs(1,i));
      y=nodes(2,springs(1,i));
      dx=nodes(1,springs(2,i))-x;
      dy=nodes(2,springs(2,i))-y;
      r=sqrt(dx*dx+dy*dy);
      l=springs(3,i);
      v=atan2(dy,dx);
      rot=[cos(v) -sin(v);sin(v) cos(v)];
      [X,Y]=springx(rot);
      XX=x+r*cos(v)*X-r*sin(v)*Y;
      YY=y+r*sin(v)*X+r*cos(v)*Y;
      h=line(XX,YY,'Tag','spring');
      red=max(0,r-l)/(abs(r-l)+0.01);
      blue=-min(0,r-l)/(abs(r-l)+0.01);
      set(h,'Color',[red 0 blue],'LineWidth',springs(4,i))
   end
   axis('square')
   axis('equal')
   set(gca,'XLim',[0 1],'YLim',[0 1])
   

case 'dashpot update'
   h=findobj('Type','line','Tag','dashpot');
   delete(h)
   for i=1:size(dashpots,2)
      x=nodes(1,dashpots(1,i));
      y=nodes(2,dashpots(1,i));
      dx=nodes(1,dashpots(2,i))-x;
      dy=nodes(2,dashpots(2,i))-y;
      u=velos(1,dashpots(1,i));
      v=velos(2,dashpots(1,i));
      du=velos(1,dashpots(2,i))-u;
      dv=velos(2,dashpots(2,i))-v;
      r=sqrt(dx*dx+dy*dy);
      s=sqrt(du.*du+dv.*dv);
      frict=abs(du.*dx+dv.*dy)./((r+0.0001).*(s+0.0001));
      l=dashpots(3,i);
      v=atan2(dy,dx);
      rot=[cos(v) -sin(v);sin(v) cos(v)];
      [X,Y]=dashpotx(rot);
      XX=x+r*cos(v)*X-r*sin(v)*Y;
      YY=y+r*sin(v)*X+r*cos(v)*Y;
      h=line(XX,YY,'Tag','dashpot');
 %     red=max(0,r-l)/(abs(r-l)+0.01);
 %     blue=-min(0,r-l)/(abs(r-l)+0.01);
      set(h,'Color',[frict 0 0],'LineWidth',dashpots(4,i))
   end
   axis('square')
   axis('equal')
   set(gca,'XLim',[0 1],'YLim',[0 1])
   
   
case 'fast spring update'
   h=findobj('Type','line');
   delete(h)
   for i=1:size(springs,2)
      x=nodes(1,springs(1,i));
      y=nodes(2,springs(1,i));
      dx=nodes(1,springs(2,i))-x;
      dy=nodes(2,springs(2,i))-y;
      r=sqrt(dx*dx+dy*dy);
      v=atan2(dy,dx);
      rot=[cos(v) -sin(v);sin(v) cos(v)];
      [X,Y]=springx(rot);
      XX=x+r*cos(v)*X-r*sin(v)*Y;
      YY=y+r*sin(v)*X+r*cos(v)*Y;
      h=line(XX,YY);
      set(h,'Color',[0 0 0],'LineWidth',springs(4,i))
   end
   axis('square')
   axis('equal')
   set(gca,'XLim',[0 1],'YLim',[0 1])

   
end




function gf=gravity_forces(nodes)
   hx=findobj(gcbf,'Tag','x-force');
   hy=findobj(gcbf,'Tag','y-force');
   fx=get(hx,'String');
   fy=get(hy,'String');
   gravityforce=[eval(fx); eval(fy)];
   mass=nodes(3,:);
   gf=gravityforce*mass;
   

function ff=friction_forces(velos)
   h=findobj(gcbf,'Tag','friction');
   c=get(h,'String');
   c=eval(c);
   ff=-c*velos;


function sf=spring_forces(nodes,springs)
   sf=zeros(2,size(nodes,2));
   x0=nodes(1,springs(2,:));
   y0=nodes(2,springs(2,:));
   x=nodes(1,springs(1,:));
   y=nodes(2,springs(1,:));
   dx=x-x0; dy=y-y0; r=sqrt(dx.*dx+dy.*dy);
   f=springs(4,:).*(r-springs(3,:))./springs(3,:);
   f=[dx.*f./r; dy.*f./r];
   sf(:,springs(2,:))=f;
   sf(:,springs(1,:))=sf(:,springs(1,:))-f;


function df=dashpot_forces(nodes,dashpots,velos)
   if isempty(dashpots)
      df=[];
   else
      df=zeros(2,size(nodes,2));
      x0=nodes(1,dashpots(2,:));
      y0=nodes(2,dashpots(2,:));
      x=nodes(1,dashpots(1,:));
      y=nodes(2,dashpots(1,:));
      dx=x-x0; dy=y-y0; r=sqrt(dx.*dx+dy.*dy);
      u0=velos(1,dashpots(2,:));
      v0=velos(2,dashpots(2,:));
      u=velos(1,dashpots(1,:));
      v=velos(2,dashpots(1,:));
      dx=x-x0; dy=y-y0; r=sqrt(dx.*dx+dy.*dy);
      du=u-u0; dv=v-v0; s=sqrt(du.*du+dv.*dv);
      f=dashpots(4,:).*(du.*dx+dv.*dy)./(r+0.0001);
      f=[dx.*f./(r+0.0001); dy.*f./(r+0.0001)];
      df(:,dashpots(2,:))=f;
      df(:,dashpots(1,:))=df(:,dashpots(1,:))-f;
   end
   

function [X,Y]=springx(dummy)
   X=0:.025:1;
   Y=sin(20*pi*X);
   X=[0 (X+.1)/1.1*.9 1];
   Y=[0 Y 0]/50;


function [X,Y]=dashpotx(dummy)
d=.04;
f=.2;
F=f+2/3*(1-2*f);
G=f+1/3*(1-2*f);
X=[0  f  f  F  F  f  f  f  F  F  1  G  G  G];
Y=[0  0  d  d -d -d  0 -d -d  0  0  0  d*.5 -d*.5];


function pat(nodes)
   h=findobj('Type','patch');
   delete(h)
   for i=1:size(nodes,2)
      v=0:pi/5:2*pi;
      x=nodes(1,i)+sqrt(nodes(3,i))*cos(v)/20;
      y=nodes(2,i)+sqrt(nodes(3,i))*sin(v)/20;
      h=patch(x,y,'b','Tag',num2str(i));
      if nodes(4,i)==1 set(h,'FaceColor',[0 0 0]); end
   end
   set(gca,'XLim',[0 1],'YLim',[0 1])


function index=get_node(nodes)
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   index=0;
   dist=1000000000;
   for i=1:size(nodes,2)
      newdist=norm(cp-nodes(1:2,i));
      if newdist<dist
         index=i;
         dist=newdist;
      end
   end
   
   
function index=get_spring(nodes,springs)
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   index=0;
   dist=1000000000;
   for i=1:size(springs,2)
      midp=(nodes(1:2,springs(1,i))+nodes(1:2,springs(2,i)))/2;
      newdist=norm(cp-midp);
      if newdist<dist
         index=i;
         dist=newdist;
      end
   end
 
 
 function index=get_dashpot(nodes,dashpots)
   cp=get(gca,'CurrentPoint'); cp=cp(1,1:2)';
   index=0;
   dist=1000000000;
   for i=1:size(dashpots,2)
      midp=(nodes(1:2,dashpots(1,i))+nodes(1:2,dashpots(2,i)))/2;
      newdist=norm(cp-midp);
      if newdist<dist
         index=i;
         dist=newdist;
      end
   end
 
